<?php

/**
 * ------------------------------------------------------------------------
 * BlueMind Stats Portal, aka bm-stats
 * ------------------------------------------------------------------------
 * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
 * @author  : Pascal SALAUN 
 * @Website : http://www.breizh-ltd.com <http://www.breizh-ltd.com>
 * ------------------------------------------------------------------------
 **/
 

function getToken($thisLogin,$thisPassword) {

    $bmIni = '/etc/bm/bm.ini';
    $dataBmIni = parse_ini_file($bmIni);

    $thisURL=$dataBmIni['external-protocol']."://".$dataBmIni['external-url']."/soap/proxy?wsdl" ;


    $serv = new SoapClient($thisURL, array('cache_wsdl' => WSDL_CACHE_NONE));
    $login = $serv->login(array('arg0' => $thisLogin, 'arg1' => $thisPassword, 'arg2' => 'bmStats'));
    $token = $login->return;


    if($token==null || !isset($token->sessionId) || $token->sessionId==null) {
         $thisArray = array() ;
          
    } else {
    
        require("apiClass.php");

        $userQuery = new UserQuery();
        $userQuery->id = $token->userId ;
        $info = $serv->findUsers(array('arg0' => $token, 'arg1' => $userQuery));

        $thisUser = $info->return ;

        $thisPerms       = $thisUser->perms ;
        $thisDomainName  = $thisUser->domain->name ;
        $thisDomainId    = $token->domainId ;  
        $thisDisplayName = $thisUser->displayName ;

        $thisArray['token']       = 1 ;
        $thisArray['login']       = "$thisLogin" ;
        $thisArray['password']    = "$thisPassword" ;
        $thisArray['displayName'] = $thisDisplayName ;
        $thisArray['domainName']  = $thisDomainName ;
        $thisArray['domainId']    = $thisDomainId ;
        $thisArray['perms']       = $thisPerms ;

    
    };

    $serv->logout(array('arg0' => $token));


    return $thisArray ;


}

function getAllDomain() {

    $apiKey=file("/etc/bm/bm-core.tok") ;
    $bmIni = '/etc/bm/bm.ini';

    $dataBmIni = parse_ini_file($bmIni);
    $thisURL=$dataBmIni['external-protocol']."://".$dataBmIni['external-url']."/soap/proxy?wsdl" ;



    $thisList = array() ;


    $serv = new SoapClient($thisURL, array('cache_wsdl' => WSDL_CACHE_NONE));
    $login = $serv->login(array('arg0' => 'admin0@global.virt', 'arg1' => $apiKey[0], 'arg2' => 'bmStats'));
    $token = $login->return;

    if($token==null || !isset($token->sessionId) || $token->sessionId==null) {
        echo "invalid login/password";
        exit(1);
    } else {
    }

    $userQuery = new UserQuery();

    $userQuery->domainId != 0 ;

    $users = $serv->findUsers(array('arg0' => $token, 'arg1' => $userQuery));
    foreach($users->return as $thisUser) {
        $thisDomainName  = $thisUser->domain->name ;
        $thisDomainId    = $thisUser->domain->id ;
      
        $thisList[$thisDomainId] = "$thisDomainName" ; 
    }
    $serv->logout(array('arg0' => $token));

    return $thisList ;
}

/**
the domain is get from session values

*/

function listAllUserForThisDomain() {

    require("apiClass.php");


    $apiKey=file("/etc/bm/bm-core.tok") ;
    $bmIni = '/etc/bm/bm.ini';

    $dataBmIni = parse_ini_file($bmIni);
    $thisURL=$dataBmIni['external-protocol']."://".$dataBmIni['external-url']."/soap/proxy?wsdl" ;

    $thisList = array() ;


    $serv = new SoapClient($thisURL, array('cache_wsdl' => WSDL_CACHE_NONE));
    $login = $serv->login(array('arg0' => 'admin0@global.virt', 'arg1' => $apiKey[0], 'arg2' => 'bmStats'));
    $token = $login->return;

    if($token==null || !isset($token->sessionId) || $token->sessionId==null) {
        echo "invalid login/password";
        exit(1);
    } else {
    }

    $userQuery = new UserQuery();
    $userQuery->domainId = $_SESSION['domainId'];
    $users = $serv->findUsers(array('arg0' => $token, 'arg1' => $userQuery));

    foreach($users->return as $user) {

        if(isset($user->emails->entry)) {
            $thisList[]= $user->login;
        }
    }

    $serv->logout(array('arg0' => $token));

    sort($thisList) ;

    return array_unique($thisList) ;
 
}
?>
